  PROGRAM

impFile     FILE,PRE(IMP),DRIVER('ASCII')
Rec         RECORD
Line        STRING(3000)
            ..

ExportFile  FILE,PRE(EXP),DRIVER('ASCII'),CREATE,NAME('export.txt')
Rec         RECORD
Line        STRING(500)
            ..

nBranches   EQUATE(27)
maxLen      EQUATE(80)

dNode       CLASS,TYPE
n           ULONG(0)
s           CSTRING(maxLen+1)
            END

bNode       CLASS,TYPE
n           ULONG(0)
p           LONG(0),DIM(nBranches)
            END

  INCLUDE('Trie.INC'),ONCE

  MAP
  END

  CODE

!----------------------------------------------------
Trie.Construct             PROCEDURE()
!----------------------------------------------------

   CODE

!----------------------------------------------------
Trie.Destruct              PROCEDURE()
!----------------------------------------------------

   CODE

!-----------------------------------------------------------------------------
Trie.Init              PROCEDURE(STRING fname)
!-----------------------------------------------------------------------------
s   STRING(maxLen)
pos ULONG(1)
m   ULONG(1)

    CODE
    
    impFile{PROP:Name} = fName
    OPEN(impFile)
    IF ERRORCODE()
      MESSAGE(ERRORCODE() &' ' &ERROR())
      RETURN FALSE
    END
    
    SELF.root = 0
    SET(impFile)
    LOOP
      NEXT(impFile)
      IF ERRORCODE() THEN BREAK.
      CLEAR(s)
      LOOP WHILE SELF.GetWord(Imp:Line,s,pos) > 0
        m=1
        MESSAGE(s)
        SELF.root = SELF.inst(s,SELF.root,m)
        CLEAR(s)
      END
      pos=1
    END
    
    CLOSE(impFile)
    RETURN TRUE

!-----------------------------------------------------------------------------
Trie.getWord             PROCEDURE(*STRING input, *STRING s, *ULONG pos)
!-----------------------------------------------------------------------------

ch  STRING(1)
i   ULONG(1)
j   ULONG(1)

    CODE
    IF pos >= LEN(CLIP(input)) THEN RETURN 0.

    LOOP i = pos TO LEN(CLIP(input))
      IF (UPPER(input[i]) < 'A' OR UPPER(input[i]) > 'Z')
        BREAK
      ELSE
        s[j] = UPPER(input[i])
        j+=1
        CYCLE
      END
    END
    pos = i+1

    RETURN LEN(CLIP(s))
    

!-----------------------------------------------------------------------------
Trie.kill               PROCEDURE()
!-----------------------------------------------------------------------------

    CODE

    SELF.rem(SELF.root)

!-----------------------------------------------------------------------------
Trie.rem               PROCEDURE(LONG r)
!-----------------------------------------------------------------------------
t   &dNode
q   &bNode
i   ULONG(0)

    CODE

    IF r
      t &= (r)
      IF t.n = 0
        q &= (r)
        LOOP i = 1 TO nBranches
          IF q.p[i] THEN SELF.rem(q.p[i]).
        END
      END
      DISPOSE(t)
    END

!-----------------------------------------------------------------------------
Trie.inst               PROCEDURE(*STRING s,LONG r,*ULONG m)
!-----------------------------------------------------------------------------

PP  LONG(0)
q   LONG(0)
t   &DNode
p   &BNode
j   LONG(0)
i   LONG(0)

    CODE
    
    pp = r
    q = pp
    IF q = 0 THEN RETURN SELF.NewNode(s).
    
    t &= (q)
    IF t.n > 0
      IF s = t.s
        t.n += 1
        RETURN q
      END
      pp = SELF.NewNode(' ')
      q = pp
      j = SELF.pos(t.s[m])
      p &= (q)
      p.p[j] = ADDRESS(t)
    END
    i = SELF.pos(s[m])
    m+=1
    p &= (q)
    p.p[i] = SELF.inst(s,p.p[i],m)
    q = pp
    RETURN q

!-----------------------------------------------------------------------------
Trie.pr               PROCEDURE()
!-----------------------------------------------------------------------------

    CODE

    CREATE(ExportFile)
    OPEN(ExportFile)
?   ASSERT(~ERRORCODE())

    SELF.prnt(SELF.root)
    CLOSE(ExportFile)

!-----------------------------------------------------------------------------
Trie.prnt               PROCEDURE(LONG r)
!-----------------------------------------------------------------------------

i   ULONG
t   &dNode
q   &bNode

    CODE

    IF r
      t &= (r)
      IF t.n
        Exp:Line = t.n &' ' &t.s
        ADD(ExportFile)
      ELSE
        q &= (r)
        LOOP i = 1 TO nBranches
          IF q.p[i] THEN SELF.prnt(q.p[i]).
        END
      END
    END

!-----------------------------------------------------------------------------
Trie.search               PROCEDURE(*STRING s)
!-----------------------------------------------------------------------------
ch  STRING(1)
m   ULONG(1)
i   ULONG(0)
q   &bNode
t   &dNode
r   LONG(0)

    CODE
    
    IF SELF.root = 0 THEN RETURN FALSE.
 
    r = SELF.root
 
    LOOP WHILE r <> 0 AND m <= LEN(CLIP(s))
      q &= (r)
      IF q.n <> 0 THEN BREAK.
      ch = UPPER(s[m])
      m+=1
      i = SELF.pos(ch)
      IF i < 1 OR i > nBranches THEN RETURN FALSE.
      r = q.p[i]
    END

    IF r = 0 THEN RETURN FALSE.

    t &= (r)

    RETURN CHOOSE(CLIP(t.s) = CLIP(UPPER(s)), TRUE, FALSE)

!-----------------------------------------------------------------------------
Trie.NewNode               PROCEDURE(STRING s)
!-----------------------------------------------------------------------------

    CODE

    IF s
      SELF.CurrD &= NEW(dNode)
?     ASSERT(~SELF.CurrD &= NULL)

      SELF.CurrD.n = 1
      SELF.CurrD.s = s
      RETURN ADDRESS(SELF.CurrD)
   ELSE
      SELF.CurrB &= NEW(bNode)
?     ASSERT(~SELF.CurrB &= NULL)

      SELF.CurrB.n = 0
      RETURN ADDRESS(SELF.CurrB)
   END

   RETURN 0




!-----------------------------------------------------------------------------
Trie.pos               PROCEDURE(STRING ch)
!-----------------------------------------------------------------------------

    CODE

    IF ch
      RETURN val(ch[1]) - val('A') + 2
    END

    RETURN 1


